  
function a = kpca(hyper)   
    
% KPCA kpca object - Kernel Principal Components Analysis  
%    
% A=KPCA(H) returns a kpca object initialized with hyperparameters H.   
%  
% Hyperparameters, and their defaults  
%  feat=0;              -- number of features, default 0 means all via rank(K)  
%  child=[]             -- the kernel is stored as a member called "child"  
%                          but as default assumes data coming in is *already*  
%                          a kernel.  
% Model  
%  e_val                -- the eigenvectors  
%  e_vec                -- the eigenvalues  
%  offset               -- the offsets  
%  dat                  -- training data (that we extracted from)  
%  
% Methods:  
%  train, test  
    
    
  %hyperparams   
  a.feat=0;  
  a.child=[];  
    
  % model   
  a.e_vec=[]; % eigenvectors  
  a.e_val=0;  % eigenvalues  
  a.offset=[];  % offset     
  a.dat=[];  
    
  p=algorithm('kpca');  
  a= class(a,'kpca',p);  
   
  
  if nargin==1,  
    eval_hyper;  
  end;  
