function a = fsv(hyper) 
% FSV fsv object - Feature Selection Convave
% 
% A=FSV(H) returns a fsv object initialized with hyperparameters H. 
%
% Hyperparameters, and their defaults
%  lambda=1             -- the lambda parameter beteen 0 and 1. 
%                          (1=min. zero norm, 0=min. hinge loss)
%  alpha=5              -- the alpha parameter 
%  feat=[]              -- number of desired features (if empty gives
%`                         the smallest)
%  output_rank=0        -- when set to 1, output features only
%
% Model
%  rank                 -- the rank of the features
%  w                    -- the weight
%  b0                   -- the threshold
%  
% Methods:
%  training, testing 
  % model 
  a.rank=[];
  a.w=[];
  a.b0=0;
  a.feat=[];
  a.output_rank=0; % don't output labels, output selected features 
    
  % parameters
  a.lambda=1;
  a.alpha=5;
  
  p=algorithm('fsv');
  a= class(a,'fsv',p);
    if nargin==1,
     eval_hyper;
  end;  
  
 
