
function a = knn(hyper) 
%
% KNN k-nearest neighbours object  
% a = knn(hyperParam)
% 
% Generates a knn object with given hyperparamters.
%
% Hyperparameters (with defaults)
%  k=1                  -- number of neighbours
%  batch=1              -- true if to be computed in batch 
%                           (requires more memory)
%  child=kernel;        -- kernel function (distances computation/ 
%                           default is linear kernel)
%  output_preimage=0    -- whether output index from training sample 
%                           of preimage 
%                          instead of actual label
%
% Model
%  dat                  -- data used for neighbours computation
%
% Methods:
%  train, test
  
  % <<------------hyperparams initialisation -------->>
  a.k=1;
  a.child=kernel;  
  a.no_train=0;
  a.batch=1;
  a.output_preimage=0;
  
  % <<-------------model-------------------------->> 
  a.dat=[];
    
  algoType=algorithm('knn');
  a= class(a,'knn',algoType);
  if nargin==1,
    eval_hyper;
  end;  
   


