function w = get_w(sv,method) 
% w = get_w() 
% returns value of w from svm 
% AE: i have changed this procedure to include non linear feature
% selection with RFE. When non-linear, it gives  a score vector for each
% feature (used in RFE) which is not the margin but is sorted as the margin
kertmp = sv.child.kerparam;
if strcmp(sv.child.ker,'linear')
  w=sv.alpha'*get_x(sv.Xsv);
  return;
end
if strcmp(sv.child.ker,'weighted_linear')
  l=get_dim(sv.Xsv);
  w=sv.alpha'* (get_x(sv.Xsv) .*  repmat(kertmp,l,1));
return;
end
if strcmp(sv.child.ker,'rbf')  | strcmp(sv.child.ker,'poly'),
    Xtmp = get_x(sv.Xsv);
    alphatmp = sv.alpha;
    
    if strcmp(sv.child.ker,'rbf'),
        
      % compute the kernel matrix for all components
      K = Xtmp*Xtmp';
      Kdn = sum(Xtmp.^2,2);
      Kn = sum(Xtmp.^2,2);
      K = ones(size(Xtmp,1),1)*Kdn' + Kn*ones(1,size(Xtmp,1)) - 2*K;
      K = exp(-K/(2*kertmp));
      % compute the margin when one component is removed
       for i = 1:size(Xtmp,2),
           Ki = Xtmp(:,i)*ones(1,size(Xtmp,1)) - ones(size(Xtmp,1),1)*Xtmp(:,i)';
           Ki = Ki.^2;
           Ki = Ki/(2*kertmp); 
           Ki = exp(Ki);
           w(i) = (alphatmp'*(K.*Ki)*alphatmp);
       end;
    elseif strcmp(sv.child.ker,'poly'),
        % compute the margin when one component is removed
        Ktmp = Xtmp*Xtmp';
        for i = 1:size(Xtmp,2),
           Ki = Xtmp(:,i)*Xtmp(:,i)';
           K_i = (Ktmp - Ki+1).^(kertmp);           
           w(i) = (alphatmp'*K_i*alphatmp);
    	end;    
    end;% if strcmp(...,'rbf')
    w=max(w)-w;  %% make largest the smallest --- wrong way round!
    return;
end;% if strcmp(... | strcmp(...,'poly')
%%% if this point is reached then the kernel is a non classic one
ker=sv.child.ker;
if strcmp(ker,'custom'),
    error('Get w not implemented for CUSTOM kernels.');
    return;
end;
%%% if tpoly kernel -> used for nfe
if strcmp(ker,'tpoly'),
    [l,n,k]=get_dim(sv.Xsv);    
    Xtmp = get_x(sv.Xsv);
    alphatmp = sv.alpha;
    w = ones(length(sv.child.param,n));
    
    for j=1:length(sv.child.kerparam),  
        ktmp = sv.child;
        kerp = ktmp.kerparam;
        for i = 1:length(kerp{j}),
            kerptmp=kerp;
            kerptmp{j} = [kerp{j}(1:i-1),kerp{j}(i+1:length(kerp{j}))];    
            ktmp.kerparam=kerptmp;
            K_i = get_kernel(ktmp,sv.Xsv,sv.Xsv);            
            w(j,kerp{j}(i)) = (alphatmp'*K_i*alphatmp);
        end; 
    end;
    w = max(max(w))-w;
    return;
end;
for i = 1:size(Xtmp,2),
    dtmp = data('tmp',[Xtmp(:,1:(i-1)),Xtmp(:,(i+1):size(Xtmp,2))],[]);
    Ki = get_kernel(sv.child,dtmp,dtmp);      
    w(i) = (alphatmp'*Ki*alphatmp);
end;   
w=max(w)-w;