function Beta=getoptimalcoef(a,X,Alphas,Z,gamma)

% X is a nxm matrix...n training examples of dimension m
% Z is a nxm matrix ..the reduced set
% Alphas are the original expansion Column matrix
% beta is the reduced set expansion...Column Matrix

% Add a kernel function handle later...for now tune it to the Gaussian kernel..

Kz=gaussianKernel(Z,Z,gamma);
Kzx=gaussianKernel(Z,X,gamma);

Beta1=inv(Kz)*Kzx*Alphas;
Beta=Beta1';
size(Beta);


function C = gaussianKernel(A,B,gamma)


[numA dim]=size(A);
[numB dim]=size(B);

for i=1:numA
    for j=1:numB
    
        C(i,j)=exp(-gamma*norm(A(i,:)-B(j,:))^2);
        
    end
end



