function [d,alg] =  training(a,d)
  
  if a.algorithm.verbosity>0
    disp(['training ' get_name(a) '.... '])
  end


 alg=a;
 signed_flag=a.original.algorithm.use_signed_output;
 a.original.algorithm.use_signed_output=0;
 R=test(a.original,d);
 R=get_x(R);
 R0=R;
 
 nr_of_points=length(R);
 
 D_orthogonal_history=zeros(nr_of_points,a.N);
 

 [l,n,k]=get_dim(d);
 
 alpha=zeros(a.N,1);
 Xsv=zeros(a.N,n);
 
 X=get_x(d);

	% getdb_orthogonal()  
	
	for i=1:a.N

	 display(['Iteration:  ' sprintf('%d',i ) ' Error: ' 	sprintf('%f',norm(R)) ]);

	 [zi D_orthogonal index]=optimize_finite_z(a.original.child,X,R);

	
	
	


	 D_orthogonal_history(:,i)=D_orthogonal;


	 %calculate projection of R on k(z,.)/||k(z,.)||
	 alpha(i)=D_orthogonal'*R/norm(D_orthogonal)^2;


	 %update residual
	 %subtract projection on k(z,.)/||k(z,.)|| from R
	 R=R- alpha(i)*D_orthogonal;


	 %backfitting step
	 for k=1:i-1
             % $\alpha_k = alpha_k - alpha_i*beta_k(zi)
	  alpha(k)=alpha(k)-alpha(i)*calcbeta(D_orthogonal_history(:,k),D_orthogonal_history(:,i)) ;
	 end
        
	

	 Xsv(i,:)=zi;

		
	end

  
	X=get_x(d);
	
	for  i=1:a.N
	
	 alg.child{i}=a.original;
	 alg.child{i}.Xsv=data(Xsv(1:i,:),[]);
	 alg.child{i}.alpha=alpha(1:i);
	 alg.child{i}.child.dat=[];
	 alg.child{i}.algorithm.use_signed_output=0;

	 R=test(alg.child{i},data(X,[]));
	 alg.child{i}.algorithm.use_signed_output=signed_flag;
	 alg.child{i}.b0=mean(R.X);
  	
	end
	
	display(['final Reconstruction Error: '  sprintf('%f',norm(R0-R.X)) ]);

	
  	

  

  if ~a.algorithm.do_not_evaluate_training_error
  
  else
      display('eval training error');
  end
  


 %% .........calc the beta's.............
function beta=calcbeta(d_orthogonal_k,d_orthogonal_i)

num=d_orthogonal_k'*d_orthogonal_i;
denum=norm(d_orthogonal_k)*norm(d_orthogonal_k);

beta=num/denum;




function [zi,D_orthogonal,index]=optimize_finite_z(k,X,R)

epsilon=1e-4;

sx=size(X);
nr_of_samples=sx(1,1);
dim_of_samples=sx(1,2);


%   while reset==0

     
     
%     display(sprintf('optimize-z Iteration: %d %f',iteration,difference));
%     [z_old ;	z]
     
     Y=test(k,data( X,[]));
     K=get_x(Y);
     
     %% evaluation of k(z,x_i)
     m=K(1,:)*R/norm(K(1,:));
     mi=1;
     for i=2:nr_of_samples
         if m < abs((K(i,:)*R/norm(K(i,:))))
            m=abs(K(i,:)*R/norm(K(i,:)));
            mi=i;
         end
     end
     
     
%     
index=mi;
 zi=X(mi,:);
 D_orthogonal=K(mi,:)';
% 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function z=getRand(Domain)

	for i=1:length(Domain)
	 z(i)=Domain(i)*rand(1);
	end

